require_relative '../../support/helper'
require_relative '../../support/lib/simple_handler.rb'

require 'tango/etl/dispatcher'

class TestDispatcher < Test::Unit::TestCase
      
  context "handler dispatcher" do
      
    setup do
      @dispatcher = Tango::ETL::Dispatcher.new
    end
    
    should "throw exception when trying to register handler that does not implement HandlerInterface" do
      assert_raise RuntimeError do
         @dispatcher.register( Object )
       end
    end
    
    should "register handler and stay chainable" do
      assert_equal @dispatcher, @dispatcher.register( SimpleHandler )
    end
    
    should "find handler for a suitable link" do
      @dispatcher.register( SimpleHandler ) # SimpleHandler works only with '/index.html' link
      assert_equal SimpleHandler, @dispatcher.find_handler( '/index.html' )
    end
    
    should "return nil if there is no handler suitable for a link" do
      @dispatcher.register( SimpleHandler ) # SimpleHandler works only with '/index.html' link
      assert_equal nil, @dispatcher.find_handler( '/picutres/1.html' )
    end
  
  end
  
end