require_relative '../support/helper'

require 'active_record'
require 'activerecord-nulldb-adapter'

require 'tango/abstract_model'
require_relative '../support/lib/user.rb'


class TestAbstractModel < Test::Unit::TestCase
      
  context "instance of a model that extends AbstractModel" do
    
    setup do
      
      ActiveRecord::Base.establish_connection :adapter => :nulldb, 
                                              :schema  => Dir.pwd + '/test/support/db/schema.rb'
      @model = Model::User.new
      @model.name = "Maciej"
      @model.age = 22
      
    end
    
    should "have cache key" do
      assert_equal ["Maciej", 22], @model.cache_key
    end
    
    should "have array list with its properties values" do
      assert_equal [nil, "Maciej", 22], @model.values
    end
    
  end
  
  context "model class that extends AbstractModel" do
    
    should "know what is the next available id" do
      assert_equal 1, Model::User.next_id
      assert_equal 2, Model::User.next_id
    end
    
  end
  
end