require_relative '../support/helper'

require 'tango/database_locker'

class TestDatabaseLocker < Test::Unit::TestCase
      
  context "a database locker" do
    
    setup do
      @lock_path = './tmp/database_test.lock'
      @locker = Tango::DatabaseLocker.new( ["master", "slave"], @lock_path )
    end
    
    teardown do
      File.delete( @lock_path )
    end
    
    should "create lock file" do
      @locker.lock( "master" )
      assert File.exists?( @lock_path )
      assert_equal "master", IO.read( @lock_path )
    end
    
    should "find unlocked database" do
       @locker.lock( "slave" )
       assert_equal "master", @locker.unlocked
    end
      
  end
end