require_relative '../support/helper'

require 'tango/kernel'
require 'tango/abstract_model.rb'

class TestKernel < Test::Unit::TestCase
      
  context "a kernel" do
    
    setup do
      
      @lib_path = File.join( File.expand_path( '../../', __FILE__ ), 'support', 'lib' )
      
      Dir.glob( File.join( @lib_path,  '*.rb' ) ) do |f|
        require f
      end
      
    end

    should "load classes in module" do
      assert_equal [Foo::A, Foo::B, Foo::C], Tango::Kernel.module_classes( Foo )
    end
    
    should "obtain symbol from a class" do
      assert_equal :simple_buffer, Tango::Kernel.symbolize( SimpleBuffer )
    end
    
    should "obtain symbol from a class in a module" do
      assert_equal :user, Tango::Kernel.symbolize( Model::User )
    end
    
  end
  
end